Attribute VB_Name = "modListView"
' Modulname : vbzListView.bas
' Version   : Auszug fr XPTheme Demo!
' Stand     : 28.02.2011
' Quelle    : http://www.vb-zentrum.de

' Hinweis:
' bentigt die Microsoft Windows Common Controls 5.0(SP2) - comctl32.ocx,
' da viele Funktionen, wie z.B. "lvwSetExtendedStyle" von der Version 6.0
' NICHT untersttzt werden!

Option Explicit

' Konstanten:
Public Const LVM_FIRST As Long = &H1000&
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 54)
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 55)

' ListView extended styles
Public Enum LVW_EX_STYLES
  LVS_EX_GRIDLINES = &H1&
  LVS_EX_SUBITEMIMAGES = &H2&
  LVS_EX_CHECKBOXES = &H4&
  LVS_EX_TRACKSELECT = &H8&
  LVS_EX_HEADERDRAGDROP = &H10&
  LVS_EX_FULLROWSELECT = &H20&
  LVS_EX_ONECLICKACTIVATE = &H40&
  LVS_EX_TWOCLICKACTIVATE = &H80&
  LVS_EX_FLATSB = &H100&
  LVS_EX_REGIONAL = &H200&
  LVS_EX_INFOTIP = &H400&
  LVS_EX_UNDERLINEHOT = &H800&
  LVS_EX_UNDERLINECOLD = &H1000&
  LVS_EX_MULTIWORKAREAS = &H2000&
  LVS_EX_LABELTIP = &H4000&
  LVS_EX_BORDERSELECT = &H8000&
  LVS_EX_DOUBLEBUFFER = &H10000         ' minimum OS: WinXP!
  LVS_EX_HIDELABELS = &H20000
  LVS_EX_SINGLEROW = &H40000
  LVS_EX_SNAPTOGRID = &H80000
  LVS_EX_SIMPLESELECT = &H100000
  LVS_EX_HEADERINALLVIEWS = &H2000000   ' minimum OS: Vista (header in all views)!
End Enum   ' LVW_EX_STYLES

Private Const GWL_EXSTYLE As Long = -20
Private Const GWL_HINSTANCE As Long = -6
Private Const GWL_HWNDPARENT As Long = -8
Private Const GWL_ID As Long = -12
Private Const GWL_STYLE As Long = -16
Private Const GWL_USERDATA As Long = -21
Private Const GWL_WNDPROC As Long = -4
Private Const WS_CLIPCHILDREN = &H2000000

' Declaration window and system functions:
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
        ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, _
        ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

' *** Begin XP themes and styles
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function SetWindowTheme Lib "uxtheme" (ByVal hwnd As Long, ByVal pSubAppName As Long, _
        ByVal pSubIDList As Long) As Long
Private Enum puxTHEME
  uxUNKNOWN = &H0&
  uxNONE = &H1&
  uxOKAY = &H2&
End Enum
Private uxtheme As puxTHEME
' *** End XP themes

' ListView ExplorerStyle, only for Common Controls 5.0
' Needs WinXP or newer. (Effect doesn't exist in IDE!)
Public Function lvwSetExplorerStyle(ByVal lvHwnd As Long) As Boolean
  Dim hModule As Long
  ' check if uxtheme.dll exist (only once a session for better performance!)
  If uxtheme = uxUNKNOWN Then                     ' function called first time
    hModule = LoadLibrary("uxtheme.dll")          ' try to load uxtheme.dll
    If hModule Then                               ' if exist, then
      uxtheme = uxOKAY                            ' keep success in memory
      FreeLibrary hModule                         ' and unload the library
    Else
      uxtheme = uxNONE                            ' keep info: no theme dll
    End If
  End If
  
  If uxtheme = uxOKAY Then                        ' if dll exist (see above)
    SetWindowTheme lvHwnd, StrPtr("explorer"), 0  ' set the explorer style
    lvwSetExplorerStyle = True                    ' and return "TRUE"
  End If
End Function

' ListView style extensions, only Common Controls 5.0
Public Sub lvwSetExtendedStyle(ByVal lvHwnd As Long, ByVal lStyle As LVW_EX_STYLES, ByVal flag As Boolean)
  Dim mask As Long
  
  mask = SendMessageLong(lvHwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
  If flag Then                  ' switch on style
    mask = mask Or lStyle
  Else                          ' switch off
    mask = mask And Not lStyle
  End If
  SendMessageLong lvHwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, ByVal 0&, ByVal mask
  lStyle = GetWindowLong(lvHwnd, GWL_STYLE) Or WS_CLIPCHILDREN
  SetWindowLong lvHwnd, GWL_STYLE, lStyle
End Sub
